/*
  Author: PHCC
  Date: 30/12/2020

  DEFENSE POWAS!

  This is the power for the light blue emerald (there is no infinity stone for it, but anyway...)

  This is both a passive and active power. It will ocasionally protect you from some kinds of damage at the cost
  of 1 ring per defense.

  Press BT_CUSTOM2 to stay invulnerable for 3.5 seconds at the cost of 5 rings

*/

local PROTECTION_TIME = 2*TICRATE
local INV_DURATION = 5*TICRATE/2

// Making it local for lua optimization
local gameChecker = cw_checker

addHook("ShouldDamage", function(target, inflictor, damage, damagetype)
  if (not(gameChecker(EMERALD4))) return end

  local player = cw_gems[EMERALD4].player

  // It's not the player that's holding the emerald
  if (not(target.player == player)) return end

  // Player doesn't need protection
  if (player.powers[pw_shield]) return end
  if (player.powers[pw_flashing] > 2) return end
  if (player.powers[pw_invulnerability] > 2) return end

  // The emerald does not detect environment attacks, otherwise it'd be too OP
  if (not(inflictor) and damage ~= DMG_SPIKE) return end

  // We only start the timer if we didn't do it already
  if (not(player.cw.protect))
    if (player.rings - cw_gemCosts[EMERALD4].passiveDrain < 0) return end
    player.rings = $ - cw_gemCosts[EMERALD4].passiveDrain
    S_StartSound(player.mo, 162, player)
    player.cw.protect = PROTECTION_TIME
  end

  // A true absolute defense (for enemy attacks)
  return false
end, MT_PLAYER)

local function handlePlayerDefense(player)
  if (player.cw.protect)
    player.cw.protect = $ - 1
    if (not(player.powers[pw_shield]))
      // Show a shield for fanciness
      player.powers[pw_shield] = SH_PITY
      P_SpawnShieldOrb(player)
    end
  else
    // Just setting that to a number so we don't do math with nil
    player.cw.protect = 0

    // Maybe the player got a new shield while being protected, in that case we don't remove it
    if (player.powers[pw_shield] == SH_PITY)
      player.powers[pw_shield] = SH_NONE
    end
  end
end

local function handleInvulnerability(player)
  if (player.cmd.buttons & BT_CUSTOM2 and not(player.cw.prevcmd & BT_CUSTOM2))
    if (player.powers[pw_flashing] == 0)
      if (player.rings - cw_gemCosts[EMERALD4].drain < 0) return end
      player.rings = $ - cw_gemCosts[EMERALD4].drain
      S_StartSound(player.mo, 162, player)

      player.powers[pw_flashing] = INV_DURATION
      player.powers[pw_flashing] = $ - 1
    end
  end
end

addHook("ThinkFrame", function()
  if (not(gameChecker(EMERALD4))) return end

  local player = cw_gems[EMERALD4].player

  handlePlayerDefense(player)
  handleInvulnerability(player)
  player.cw.usingGemPower = player.cw.protect > 0

end)
